#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <doslib.h>
#include "phantom.h"


static int isexist (char *fname)
{
	struct FILBUF files_buf;

	return (FILES (&files_buf, fname, 0x20) >= 0);
}

int add_attach (struct _chain **ahead, char *fname)
{
	struct _chain *child, *parent;
	if (!isexist (fname))	return FALSE;

	child = malloc (sizeof(struct _chain) + strlen (fname));
	if (!child) {
		fputs ("܂\n", stdout);
		return FALSE;
	}
	child->next = NULL;
	strcpy (child->body, fname);
	if (parent = *ahead) {
		while (parent->next) {
			parent = parent->next;
		};
		parent->next = child;
	} else {
		*ahead = child;
	}
	return TRUE;
}

static char *getfilename (char *pathname)
{
	char *ptr = pathname;
	char *head = pathname;

	while (*ptr) {
		if (codetype[*ptr]) {
			if (*ptr == ':' || *ptr == '/' || *ptr == '\\') {
				head = ++ptr;
			} else {
				ptr++;
			}
		} else {
			ptr += 2;
		}
	}

	return head;
}

void put_attach (FILE *outfp, struct _chain *attachlist,
				 struct _typelist *mimetype, char *boundary)
{
	int	size;
	FILE *infp;
	char *type;
	char readbuf[STR_LEN], writebuf[STR_LEN];

	while (attachlist) {
		fprintf (outfp, "Content-Type: %s; name=\"",
			type = search_mimetype (mimetype, attachlist->body));
		sjis2jis (readbuf, getfilename (attachlist->body));
		jis2mimeB (writebuf, readbuf);
		fputs (writebuf, outfp);
		fprintf (outfp, "\"\nContent-Disposition: attachment; filename=\"%s\"\n",
				writebuf);

		if (strcmpi (type, "text/plain")) {
			fputs ("Content-Transfer-Encoding: Base64\n\n", outfp);
			infp = fopen (attachlist->body, "rb");
			while (TRUE) {
				size = fread(readbuf, sizeof(char), 48, infp);
				if (size <= 0)	break;

				encbenc(writebuf, readbuf, size);
				fwrite(writebuf, sizeof(int), ((size * 4 / 3) + 3) / 4, outfp);
				fputc('\n', outfp);
			}
		} else {
			fputs ("Content-Transfer-Encoding: 7bit\n\n", outfp);
			infp = fopen (attachlist->body, "rt");
			while (fgets (readbuf, sizeof(readbuf), infp)) {
				sjis2jis (writebuf, readbuf);
				fputs (writebuf, outfp);
			}
		}
		fclose (infp);

		fprintf (outfp, "\n--%s", boundary);
		attachlist = attachlist->next;
	}
}

char *create_boundary ()
{
	time_t nowtime;
	struct tm tm_time;
	static char buf[SET_LEN];

	time (&nowtime);
	tm_time = *localtime (&nowtime);
	sprintf (buf, "%4.4d%2.2d%2.2d%2.2d%2.2d%2.2d_phantom2\n",
			tm_time.tm_year, tm_time.tm_mon, tm_time.tm_mday,
			tm_time.tm_hour, tm_time.tm_min, tm_time.tm_sec);

	return buf;
}
